# Chili Search - The better Search for WordPress

Power up discovery of Posts, Pages, Media, WooCommerce and bbPress using our AI-Powered Search Engine.

## Description

**Chili Search** replaces the WordPress default search with a lightning fast, full-ajax and accurate search.

By the use of cloud technologies and AI computations on Documents, Chili Search provides a fast, accurate and reliable search solution.

Search between Posts, Pages, Media, WooCommerce products, bbPress forums and topics as soon as you start typing.

Guide your website visitors, boost sales, increase conversions and help your visitors to find what they are looking for.

Experience a Frictionless Search Experiences, regardless of the number of documents you have, **Chili Search** provides an incredibly fast search on your website backed by cloud servers.

Enjoy global Integrations, as you can manage to make your Posts, Pages, Media, WooCommerce products, bbPress forums and topics discoverable on your search.

Ease searching more than ever by Voice Search, search without typing.

[Live Demo](https://chilisearch.com/demo/?utm_source=wp_readme&utm_medium=referral) | [More Info](https://chilisearch.com?utm_source=wp_readme&utm_medium=referral)

## Features

&#9989; **Transparent Relevancy**. Take control of your relevancy rules and customize field weights.

&#9989; **Voice Search**. Ease searching more than ever by search without typing.

&#9989; **Easy Integration**. Make everything you want, available on your search results.

&#9989; **Elementor Compatibility**. Design the user experience of search using Elementor.

&#9989; **Search Filters**. Ease visitors access to what they want by filtering on document type, price or published date.

&#9989; **Phrase Match**. Match whole phrase, partial phrase or both at the sametime.

&#9989; **WooCommerce Support**. Make your online shop products available on search.

&#9989; **bbPress Support**. Enable search and discovery in forums, topics and replies.

&#9989; **Media Search**. Deliver relevant media as search result on your websites.

&#9989; **Document Files**. Search Inside Document files like Doc, Docx, PDF, PPTP, XLSX, ... files.

&#9989; **Sort Result**. Offer sorting results based on relevancy, published date and price in search page.

&#9989; **Flexible Design**. Serve your users the best design on search, feel free to customize by your own.

&#9989; **Incredible Fast**. Engage your visitors with frictionless search experiences.

&#9989; **Cloud Service**. Run your search on cloud servers which are accessible as long as internet is working.

&#9989; **Cross Platform**. Bring the power of search to your application, regardless the platform and stack.

## Try the premium version

You can use free features always for free and take a trial Premium Chili Search for 7 days without needing a credit card.

[Pricing](https://chilisearch.com/pricing/?utm_source=wp_readme&utm_medium=referral)

## Demo

There are multiple Chili Search Demo live on [chilisearch.com/demo](https://chilisearch.com/demo/). Results appear after typing just one letter in the search input.

## Installation

1. Install the plugin from within the Dashboard or upload the directory `chilisearch` and all its contents to the `/wp-content/plugins/` directory.
2. Activate the plugin through the 'Plugins' menu in WordPress.
3. Go to `Chili Search` and accept terms and conditions.
4. Enable `Auto search input detection` in Chili Search Setting tab or go to the `Appearance → Widgets` and choose `Search Form`
5. Everything is done, visit your website and enjoy searching!

If you run into any trouble, feel free to shoot us an email at [support@chilisearch.com](mailto:support@chilisearch.com), we will reply as soon as possible!

## Frequently Asked Questions

### Does Chili Search wordpress plugin work with any theme?

Yes! it works with most of the wordpress themes by default but for some of the themes you need to configure `Search input selector` manually in Chili Search setting page. Also you can use Chili Search plugin regardless of your theme.

### Can I choose where to search and where not to?

Sure! you can visit Chili Search setting page and manage it in `Where to search` tab.


For questions and answers, please see our website [chilisearch.com](https://chilisearch.com?utm_source=wp_readme&utm_medium=referral)

## Changelog

### 2.0.4
* add gift code
* add voice search
* add elementor compatibility
* add analytics and statistics

### 2.0.3
* fix internationalization

### 2.0.2
* update readme files and banner

### 2.0.1
* add comma at the end of JS command to prevent minifiers crash
* fix progressbar css
* add link to review page

### 2.0.0
* major update
* refactor and rewrite most parts
* add premium features

### 1.1.1
* fix isRtl bug
* update contributors

### 1.1.0
* rebrand to Chili Search

### 1.0.5
* fix internationalization

### 1.0.4
* bugfix
* add internationalization

### 1.0.3
* bugfix

### 1.0.2
* minor ui bugfix

### 1.0.1
* Readme updated
* minor ui bugfix

### 1.0.0
* First version
